/* $Id: cpl_xmemory.h,v 1.7 2008/07/21 08:48:40 llundin Exp $
 *
 * This file is part of the ESO Common Pipeline Library
 * Copyright (C) 2001-2008 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: llundin $
 * $Date: 2008/07/21 08:48:40 $
 * $Revision: 1.7 $
 * $Name:  $
 */

#ifndef CPL_XMEMORY_H
#define CPL_XMEMORY_H

/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*-----------------------------------------------------------------------------
                               Function prototypes
 -----------------------------------------------------------------------------*/

void * cpl_xmemory_malloc_count(size_t);
void * cpl_xmemory_calloc_count(size_t, size_t);
void * cpl_xmemory_realloc_count(void *, size_t);
void   cpl_xmemory_free_count(void *);

void * cpl_xmemory_malloc(size_t);
void * cpl_xmemory_calloc(size_t, size_t);
void * cpl_xmemory_realloc(void *, size_t);
void   cpl_xmemory_free(void *);

void cpl_xmemory_status(int);
int  cpl_xmemory_is_empty(int);

#endif
